//
//  AiBrushBleHeader.h
//  AiBrushBleSDK
//
//  Created by iot_user on 2019/7/3.
//  Copyright © 2019 IOT. All rights reserved.
//

#ifndef AiBrushBleHeader_h
#define AiBrushBleHeader_h

typedef NS_ENUM(NSUInteger, AiBrushBleState) {
    AiBrushBleStateUnavailable  = 0 , //Bluetooth is not available(蓝牙不可用)
    AiBrushBleStateAvailable    = 1 , //Bluetooth is available(蓝牙打开可用)
    AiBrushBleStateScaning      = 2 , //Scanning...(正在扫描...)
    AiBrushBleStateStopScan     = 3 , //Stop scanning(停止扫描)
    AiBrushBleStateWillConnect  = 4 , //Will connect(将要连接)
    AiBrushBleStateConnectFail  = 5 , //Connection error(连接出错)
    AiBrushBleStateDidConnect   = 6 , //connection succeeded(连接成功)
    AiBrushBleStateDidDisconnect = 7 , //Disconnect(断开连接)
    AiBrushBleStateDidUpdateCharacteristicState = 8 , //Update feature status, in which you can send relevant settings to Bluetooth(更新特征状态，可在这个状态时发送相关设置给蓝牙)
    
};
//Toothbrush type(牙刷类型)
typedef NS_ENUM(NSUInteger, AiBrushVersionType) {
    AiBrushVersionTypeOther = 0, //Other general modules(其他通用模块)
    AiBrushVersionTypeBY01  = 1, //BY00,01
    AiBrushVersionTypeBY02  = 2, //...2
    AiBrushVersionTypeBY03  = 3, //...
    AiBrushVersionTypeBY04  = 4, //..
    AiBrushVersionTypeBY05  = 5, //.
    AiBrushVersionTypeBY06  = 6, //
};

//Set mode result(设置模式结果)
typedef NS_ENUM(NSUInteger, AiBrushSetModeResult) {
    AiBrushSetModeResult_Suc     = 0x01,    //successfully(成功)
    AiBrushSetModeResult_Fail      = 0x02,  //failed(失败)
    AiBrushSetModeResult_NotSupport  = 0x03,//unsupport(不支持)
};

//app支持的刷牙模式
typedef NS_ENUM(NSUInteger, AiBrushSupportBrushMode) {
    AiBrushSupportBrushMode_Clean             = 0x01,//Clean(清洁)
    AiBrushSupportBrushMode_White             = 0x02,//White (美白)
    AiBrushSupportBrushMode_Massage           = 0x03,//Massage(按摩)
    AiBrushSupportBrushMode_Sensitive         = 0x04,//Sensitive(敏感)
    AiBrushSupportBrushMode_Preset            = 0x05,//Preset(定制)
    AiBrushSupportBrushMode_Custom            = 0x06,//Custom(自定义)
    AiBrushSupportBrushMode_Polish            = 0x07,//Polish(抛光)
    AiBrushSupportBrushMode_GumCare           = 0x08,//GumCare(牙龈护理)
    AiBrushSupportBrushMode_MouthwashCare     = 0x09,//MouthwashCare(漱口护理)
    AiBrushSupportBrushMode_Mascare           = 0x0A,//Mascare (保健)
    AiBrushSupportBrushMode_Soft              = 0x0B,//Soft (舒缓)
};


#endif /* AiBrushBleHeader_h */
