//
//  AiBrushWorkDataModel.h
//  AiBrushBleSDK
//
//  Created by iot_user on 2019/7/11.
//  Copyright © 2019 IOT. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "AiBrushBleHeader.h"

NS_ASSUME_NONNULL_BEGIN

@interface AiBrushWorkDataModel : NSObject

/**
 Data number(数据编号)
 -1:Representation is work data(表示是工作数据)
 Other: indicates historical data(其他：表示是历史数据)
 */
@property (nonatomic, assign) int dataNumber;

/**
 Brushing mode(刷牙模式)
 */
@property (nonatomic, assign) AiBrushSupportBrushMode brushMode;
//Custom mode or frequency(自定义模式或频率)
/*
 When brushMode = AiBrushSupportBrushMode_Preset, it is represented as a custom number (1~5 corresponds to custom mode 1 - 5);
   When brushMode = AiBrushSupportBrushMode_Custom, it is expressed as frequency (1~8 files corresponding to 180HZ-320HZ);
   0x00 means default
 (当 brushMode = AiBrushSupportBrushMode_Preset 时，表示为自定义编号(1~5 对应自定义模式 1 - 5);
 当 brushMode = AiBrushSupportBrushMode_Custom 时，表示为频率(1~8 档对应 180HZ-320HZ);
 为0x00表示默认)
 */
@property (nonatomic, assign) Byte modeOrFrequency;
//Duty cycle (1~8 file corresponds to 30%-100%), 0x00 means default(占空比(1~8 档对应 30%-100%),为0x00表示默认)
@property (nonatomic, assign) Byte duty;
//work time(工作时长)
//持续时间(单位:S):0x01----60s，0x02----70s，0x03----80s，0x04----90s，0x05----100s，......，0x18----290s，0x19----300s;
@property (nonatomic, assign) Byte workTime;

/**
 Start time (unit: s)(开始时间（单位:s）)
 */
@property (nonatomic, assign) int startTime;

/**
 work time(工作时长)
 */
@property (nonatomic, assign) int workDuration;

/**
 Excessive force(力度过大次数)
 */
@property (nonatomic, assign) int strengthCount;

/**
  Excessive strength(力度过大时长)
 */
@property (nonatomic, assign) int strengthTime;

/**
 Length of brushing on the left(左边刷牙时长)
 */
@property (nonatomic, assign) int leftTime;

/**
 Brushing time on the right(右边刷牙时长)
 */
@property (nonatomic, assign) int rightTime;


@end

NS_ASSUME_NONNULL_END
